<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents.html">capabilityAgents</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1alerts.html">alerts</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage.html">storage</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html">AlertStorageInterface</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_alert_storage_interface_8h_source.html">AlertStorageInterface.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface:</div>
<div class="dyncontent">
<div class="center"><img src="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface__inherit__graph.png" border="0" usemap="#alexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface_inherit__map" alt="Inheritance graph"/></div>
<map name="alexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface_inherit__map" id="alexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface_inherit__map">
<area shape="rect" id="node2" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html" title="alexaClientSDK::capability\lAgents::alerts::storage\l::SQLiteAlertStorage" alt="" coords="241,5,419,57"/>
<area shape="rect" id="node3" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html" title="alexaClientSDK::capability\lAgents::alerts::test::MockAlert\lStorage" alt="" coords="231,81,429,133"/>
<area shape="rect" id="node4" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html" title="alexaClientSDK::capability\lAgents::alerts::test::StubAlert\lStorage" alt="" coords="233,157,427,209"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a49472e6059c7d23d14b0c9b2bc27b02d"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a49472e6059c7d23d14b0c9b2bc27b02d">~AlertStorageInterface</a> ()=default</td></tr>
<tr class="separator:a49472e6059c7d23d14b0c9b2bc27b02d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac86a85d16a239e3b56442234745513a3"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#ac86a85d16a239e3b56442234745513a3">createDatabase</a> ()=0</td></tr>
<tr class="separator:ac86a85d16a239e3b56442234745513a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa33bc6984afc9bc5ab46ace4041ecbf6"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#aa33bc6984afc9bc5ab46ace4041ecbf6">open</a> ()=0</td></tr>
<tr class="separator:aa33bc6984afc9bc5ab46ace4041ecbf6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b5186ee46f04b46fcff8cffe8e0abc3"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a9b5186ee46f04b46fcff8cffe8e0abc3">close</a> ()=0</td></tr>
<tr class="separator:a9b5186ee46f04b46fcff8cffe8e0abc3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a555731d57f81ca06094b252859aba5ba"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a555731d57f81ca06094b252859aba5ba">store</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt; alert)=0</td></tr>
<tr class="separator:a555731d57f81ca06094b252859aba5ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2f96728dfa51cdbb83a14f07b016b17b"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a2f96728dfa51cdbb83a14f07b016b17b">load</a> (std::vector&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&gt; *alertContainer)=0</td></tr>
<tr class="separator:a2f96728dfa51cdbb83a14f07b016b17b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a534b5dcd3676ee798f90cf29d95442d8"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a534b5dcd3676ee798f90cf29d95442d8">modify</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt; alert)=0</td></tr>
<tr class="separator:a534b5dcd3676ee798f90cf29d95442d8"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5cff81a79ad29664c0e169adfa0799d4"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a5cff81a79ad29664c0e169adfa0799d4">erase</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt; alert)=0</td></tr>
<tr class="separator:a5cff81a79ad29664c0e169adfa0799d4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aa5aa64937f26592a631500b2572c1bab"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#aa5aa64937f26592a631500b2572c1bab">bulkErase</a> (const std::list&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&gt; &amp;alertList)=0</td></tr>
<tr class="separator:aa5aa64937f26592a631500b2572c1bab"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a81266ad4f52672d03cabe0a5ceab45f1"><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_alert_storage_interface.html#a81266ad4f52672d03cabe0a5ceab45f1">clearDatabase</a> ()=0</td></tr>
<tr class="separator:a81266ad4f52672d03cabe0a5ceab45f1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">An Interface class which defines APIs for interacting with a general database, as well as for storing, loading, and modifying Alerts. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a49472e6059c7d23d14b0c9b2bc27b02d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a49472e6059c7d23d14b0c9b2bc27b02d">&#9670;&nbsp;</a></span>~AlertStorageInterface()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::~AlertStorageInterface </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="aa5aa64937f26592a631500b2572c1bab"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa5aa64937f26592a631500b2572c1bab">&#9670;&nbsp;</a></span>bulkErase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::bulkErase </td>
          <td>(</td>
          <td class="paramtype">const std::list&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&gt; &amp;&#160;</td>
          <td class="paramname"><em>alertList</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Erases multiple alerts from the database. This function must be atomic, no alert is to be deleted if there was an error deleting one. </p><dl class="section note"><dt>Note</dt><dd>It is not an error if an alert in the parameter list is not present in the database. This accommodates the race condition between an local alert deletion and a request from AVS.</dd></dl>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">alertList</td><td>The list of alerts to be erased. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether all alerts were successfully erased. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#a7f86be6f37eadb48b00a3731b3372250">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a120de053dd6de7b3fd378df3aeb131ee">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a81266ad4f52672d03cabe0a5ceab45f1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a81266ad4f52672d03cabe0a5ceab45f1">&#9670;&nbsp;</a></span>clearDatabase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::clearDatabase </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">A utility function to clear the database of all records. Note that the database will still exist, as will the tables. Only the rows will be erased.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether the database was successfully cleared. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#a0d408752481020f7a51f0043f6a6c263">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#adee71480008254fba1009c2007bace25">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a9b5186ee46f04b46fcff8cffe8e0abc3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9b5186ee46f04b46fcff8cffe8e0abc3">&#9670;&nbsp;</a></span>close()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::close </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Close the currently open database, if one is open. </p>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html#a8a5dcd6bcc7c56537665d50bd249a6db">alexaClientSDK::capabilityAgents::alerts::test::MockAlertStorage</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#aa8831633a6fcdb41101f0e9b6bf23f4f">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a65408b44dcb45a51db35f197038a8eef">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="ac86a85d16a239e3b56442234745513a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac86a85d16a239e3b56442234745513a3">&#9670;&nbsp;</a></span>createDatabase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::createDatabase </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Creates a new database. If a database is already being handled by this object or there is another internal error, then this function returns false.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the database is created ok, or <code>false</code> if a database is already being handled by this object or there is a problem creating the database. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html#ae93c30217ff9a41f1a07c6b9dbe329a5">alexaClientSDK::capabilityAgents::alerts::test::MockAlertStorage</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#a1fb9fa958680dc8e1cfc08703457b551">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#ae6f47e4442facf10ed1d76d72f227570">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a5cff81a79ad29664c0e169adfa0799d4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5cff81a79ad29664c0e169adfa0799d4">&#9670;&nbsp;</a></span>erase()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::erase </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&#160;</td>
          <td class="paramname"><em>alert</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Erases a single alert from the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">alert</td><td>The <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> to be erased. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> was successfully erased. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#a6e1e15250402dbb272f7623347a500a6">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a87b1e90dbecb4fcd662e4050663603f0">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a2f96728dfa51cdbb83a14f07b016b17b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2f96728dfa51cdbb83a14f07b016b17b">&#9670;&nbsp;</a></span>load()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::load </td>
          <td>(</td>
          <td class="paramtype">std::vector&lt; std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&gt; *&#160;</td>
          <td class="paramname"><em>alertContainer</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Loads all alerts in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramdir">[out]</td><td class="paramname">alertContainer</td><td>The container where alerts should be stored. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the <code>Alerts</code> were successfully loaded. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html#a451316a45d0b349cd3e7ca5416619d2e">alexaClientSDK::capabilityAgents::alerts::test::MockAlertStorage</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#aeb5c736efcc3ad2cacc896fd08278c3d">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#ac3c517ddd07f43b79e7524b4f9a82574">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a534b5dcd3676ee798f90cf29d95442d8"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a534b5dcd3676ee798f90cf29d95442d8">&#9670;&nbsp;</a></span>modify()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::modify </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&#160;</td>
          <td class="paramname"><em>alert</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Updates a database record of the <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> parameter. The fields which are updated by this operation are the state and scheduled times of the alert. All other fields of an alert do not change over time, and so will not be captured in the database when calling this function.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">alert</td><td>The <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> to be modified. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> was successfully modified. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#a2906705832661a59c61b5fd4d8a50ee1">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a80bcc3996d5941e2e8b94a58258d4edc">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="aa33bc6984afc9bc5ab46ace4041ecbf6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa33bc6984afc9bc5ab46ace4041ecbf6">&#9670;&nbsp;</a></span>open()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::open </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Open an existing database. If this object is already managing an open database, or there is a problem opening the database, this function returns false.</p>
<dl class="section return"><dt>Returns</dt><dd><code>true</code> If the database is opened ok, <code>false</code> if this object is already managing an open database, or if there is another internal reason the database could not be opened. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html#a795e54da776f6face44c0659f9dd3e84">alexaClientSDK::capabilityAgents::alerts::test::MockAlertStorage</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#ac06e9122a39180f4c57f60d4de5ab93c">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a0ba223256b1709e95f00479624ef9fcd">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<a id="a555731d57f81ca06094b252859aba5ba"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a555731d57f81ca06094b252859aba5ba">&#9670;&nbsp;</a></span>store()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool alexaClientSDK::capabilityAgents::alerts::storage::AlertStorageInterface::store </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a> &gt;&#160;</td>
          <td class="paramname"><em>alert</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p class="">Stores a single <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> in the database.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">The</td><td><code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> to store. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the <code><a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1_alert.html">Alert</a></code> was successfully stored. </dd></dl>

<p>Implemented in <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_mock_alert_storage.html#a6b043e9545ab7ed4dc38b7dd92e539c2">alexaClientSDK::capabilityAgents::alerts::test::MockAlertStorage</a>, <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1test_1_1_stub_alert_storage.html#add0a4395d115c2bd62b109f1a5cff956">alexaClientSDK::capabilityAgents::alerts::test::StubAlertStorage</a>, and <a class="el" href="classalexa_client_s_d_k_1_1capability_agents_1_1alerts_1_1storage_1_1_s_q_lite_alert_storage.html#a947b310eda37ba3141ca1cfb816aed07">alexaClientSDK::capabilityAgents::alerts::storage::SQLiteAlertStorage</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>/workplace/avs-device-sdk/CapabilityAgents/Alerts/include/Alerts/Storage/<a class="el" href="_alert_storage_interface_8h_source.html">AlertStorageInterface.h</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
